<ui:composition
        xmlns:s="http://jboss.org/schema/seam/taglib"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:rich="http://richfaces.org/rich"
        xmlns:a4j="http://richfaces.org/a4j"
        xmlns:g="http://www.ihe.net/gazelle"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns="http://www.w3.org/1999/xhtml">
    <!-- params: restrictAccess: the boolean expression which is used to restrict access to some buttons and content
                 confman: the name of the bean which extends AbstractionSystemConfigurationManager
                  -->
    <!-- insert: additionalText: If you want to add text above the table which displays the configurations
                 additional_columns: additioal columns to be included between the URL and the action column -->
    <s:decorate template="/layout/panels/_panel_filter_criteria.xhtml"
                rendered="#{confman.displayListPanel}">
        <ui:insert name="filters"/>
        <ui:define name="filter_buttons">
            <a4j:commandLink title="#{messages['net.ihe.gazelle.simulators.RefreshList']}"
                             render="configTable">
                <span class="gzl-icon-refresh"/>
            </a4j:commandLink>
            <a4j:commandLink title="#{messages['gazelle.hl7.validator.ResetCriteria']}"
                             actionListener="#{confman.reset()}"
                             render="#{globalFormId}">
                <span class="fa fa-times-circle"/>
            </a4j:commandLink>
        </ui:define>
    </s:decorate>
    <s:div rendered="#{confman.displayListPanel}">
        <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
            <ui:define name="panel_title">#{messages['gazelle.simu.SystemsUnderTest']}</ui:define>
            <ui:insert name="additionalText"/>
            <h:outputText id="noConfigText"
                          rendered="#{confman.availableSystemConfigurations == null}"
                          value="#{messages['gazelle.simu.NoConfigurationAvailable']}"/>
            #{dataTableStateHolder.setAscendingOn('name')}
            <rich:dataTable id="configTable"
                            rendered="#{confman.availableSystemConfigurations != null}"
                            value="#{confman.availableSystemConfigurations}" var="currentConfig"
                            rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                            render="ds">
                <g:column id="nameColumn"
                          sortBy="#{'name'}" filterBy="#{'name'}" filterEvent="keyup"
                          sortOrder="#{dataTableStateHolder.sortOrders['name']}">
                    <ui:define name="header">#{messages['gazelle.simu.Name']}</ui:define>
                    <s:span styleClass="gzl-icon-lock" rendered="#{not currentConfig.isPublic}" title="Owned by #{currentConfig.owner}"/>
                    <s:span styleClass="gzl-icon-unlock" rendered="#{currentConfig.isPublic}"/>
                    <h:outputText value=" #{currentConfig.name}"/>
                </g:column>
                <g:column id="systemNameColumn" filterBy="#{'systemName'}" filterEvent="keyup"
                          sortBy="#{'systemName'}" sortOrder="#{dataTableStateHolder.sortOrders['name']}">
                    <ui:define name="header">#{messages['gazelle.simu.SystemName']}</ui:define>
                    <h:outputText value="#{currentConfig.systemName}"/>
                </g:column>
                <g:column id="urlColumn">
                    <ui:define name="header">#{messages['gazelle.simu.Endpoint']}</ui:define>
                    <h:outputText value="#{currentConfig.getEndpoint()}"/>
                </g:column>
                <g:column id="ownerColumn" rendered="#{identity.loggedIn}" filterEvent="keyup">
                    <ui:define name="header">#{messages['gazelle.simu.Owner']}</ui:define>
                    <h:outputText value="#{confman.getUserName(currentConfig.owner)}"/>
                    <h:outputText value=" (#{currentConfig.ownerCompany})" rendered="#{currentConfig.ownerCompany != null}"/>
                </g:column>
                <g:column>
                    <ui:define name="header">#{messages['gazelle.simulator.Usage']}</ui:define>
                    <rich:list value="#{currentConfig.listUsages}" var="currentu">
                        <h:outputText value="#{currentu.affinity.labelToDisplay} =&gt; #{currentu.transaction.keyword} (#{currentu.action})"/>
                    </rich:list>
                </g:column>
                <ui:insert name="additional_columns"/>
                <g:column id="actionColumn" rendered="#{identity.isLoggedIn()}">
                    <ui:define name="header">#{messages['users.Action']}</ui:define>
                    <div class="gzl-never-wrap">
                        <a4j:commandLink
                                actionListener="#{confman.editSelectedConfiguration(currentConfig)}"
                                render="#{globalFormId}" execute="@this"
                                rendered="#{currentConfig.isPublic ? identity.isLoggedIn() : (currentConfig.owner.equals(identity.username) or s:hasRole('admin_role'))}">
                            <s:span styleClass="gzl-icon-pencil "/>
                        </a4j:commandLink>
                        <a4j:commandLink
                                actionListener="#{confman.copySelectedConfiguration(currentConfig)}"
                                rendered="#{currentConfig.isPublic ? identity.isLoggedIn() : (currentConfig.owner.equals(identity.username) or s:hasRole('admin_role'))}"
                                execute="@this" render="#{globalFormId}">
                            <s:span styleClass="gzl-icon-files-o "/>
                        </a4j:commandLink>
                        <a4j:commandLink
                                actionListener="#{confman.setSelectedSystemConfiguration(currentConfig)}"
                                oncomplete="jq162('#delete_conf').modal('show');"
                                render="delete_confContent"
                                rendered="#{currentConfig.isPublic ? identity.isLoggedIn() : (currentConfig.owner.equals(identity.username) or s:hasRole('admin_role'))}">
                            <s:span styleClass="gzl-icon-trash-o "/>
                        </a4j:commandLink>
                    </div>
                </g:column>
                <f:facet name="footer">
                    <ui:include src="/util/datatableFooter.xhtml">
                        <ui:param name="dataScrollerId" value="ds"/>
                        <ui:param name="dataTableId" value="configTable"/>
                    </ui:include>
                </f:facet>
            </rich:dataTable>
            <ui:define name="panel_footer">
                <a4j:commandButton id="addConfigButton"
                                   actionListener="#{confman.addConfiguration()}"
                                   rendered="#{restrictAccess}"
                                   value="#{messages['gazelle.simu.CreateANewConfiguration']}"
                                   styleClass="gzl-btn-green" render="globalDiv" execute="@this"/>
            </ui:define>
        </ui:decorate>
    </s:div>
</ui:composition>
